unit ViewFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, CRVData, CRVFData, ShellAPI, RVTypes;

type
  TfrmView = class(TForm)
    RichView1: TRichView;
    RVStyle1: TRVStyle;
    procedure RichView1ReadHyperlink(Sender: TCustomRichView; const Target,
      Extras: TRVUnicodeString; DocFormat: TRVLoadFormat; var StyleNo: Integer;
      var ItemTag: TRVTag; var ItemName: TRVUnicodeString);
    procedure RichView1Jump(Sender: TObject; id: Integer);
    procedure RichView1ItemHint(Sender: TCustomRichView;
      RVData: TCustomRVData; ItemNo: Integer; var HintText: TRVUnicodeString);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


implementation

{$R *.dfm}

procedure TfrmView.RichView1ReadHyperlink(Sender: TCustomRichView;
  const Target, Extras: TRVUnicodeString; DocFormat: TRVLoadFormat;
  var StyleNo: Integer; var ItemTag: TRVTag; var ItemName: TRVUnicodeString);
begin
  if DocFormat=rvlfURL then
    StyleNo := 1;
  ItemTag := Target;
end;

procedure TfrmView.RichView1Jump(Sender: TObject; id: Integer);
var RVData: TCustomRVFormattedData;
    ItemNo: Integer;
    URL: TRVUnicodeString;
begin
  RichView1.GetJumpPointLocation(id, RVData, ItemNo);
  URL := RVData.GetItemTag(ItemNo);
  ShellExecuteW(0, 'open', PRVUnicodeChar(URL), nil, nil, SW_SHOW);
end;

procedure TfrmView.RichView1ItemHint(Sender: TCustomRichView;
  RVData: TCustomRVData; ItemNo: Integer; var HintText: TRVUnicodeString);
begin
  if RVData.GetItemTag(ItemNo) <> '' then
    HintText := RVData.GetItemTag(ItemNo);
end;

procedure TfrmView.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

end.
